---
title: How-to Guides
---

## Deployment

* [How to Deploy Databend With Local File System(For Test)](../10-deploy/00-local.md)
* [How to Deploy Databend With MinIO](../10-deploy/04-minio.md)
* [How to Deploy Databend With AWS S3](../10-deploy/01-s3.md)
* [How to Deploy Databend With Azure Blob Storage](../10-deploy/08-azure.md)
* [How to Deploy Databend With Tencent COS](../10-deploy/02-cos.md)
* [How to Deploy Databend With Alibaba OSS](../10-deploy/03-oss.md)
* [How to Deploy Databend With QingCloud QingStore](../10-deploy/07-qingstore.md)
* [How to Deploy Databend With Wasabi Object Storage](../10-deploy/05-wasabi.md)
* [How to Deploy Databend With Scaleway OS](../10-deploy/06-scw.md)
* [How to Deploy a Databend Local Cluster With MinIO](../10-deploy/00-local.md)
* [How to Deploy a Databend K8s Cluster With MinIO](../10-deploy/10-cluster-minio.md)


## Connect

* [How to Connect Databend With MySQL Client](../30-reference/00-api/01-mysql-handler.md)
* [How to Connect Databend With ClickHouse Client](../30-reference/00-api/02-clickhouse-handler.md)
* [How to Connect Databend With REST API](../30-reference/00-api/00-rest.md)
* [How to Connect Databend With DBeaver SQL IDE](../40-integrations/20-gui-tool/01-dbeaver.md)
* [How to Execute Queries in Python](../20-develop/01-python.md)
* [How to Query Databend in Jupyter Notebooks](../40-integrations/20-gui-tool/00-jupyter.md)
* [How to Execute Queries in Golang](../20-develop/00-golang.md)
* [How to Execute Queries in Node.js](../20-develop/02-nodejs.md)


## Users

* [How to Create a User](../30-reference/30-sql/00-ddl/30-user/01-user-create-user.md)
* [How to Grant Privileges to a User](../30-reference/30-sql/00-ddl/30-user/10-grant-privileges.md)
* [How to Revoke Privileges From a User](../30-reference/30-sql/00-ddl/30-user/11-revoke-privileges.md)
* [How to Create a Role](../30-reference/30-sql/00-ddl/30-user/04-user-create-role.md)
* [How to Grant Privileges to a Role](../30-reference/30-sql/00-ddl/30-user/10-grant-privileges.md)
* [How to Grant Role to a User](../30-reference/30-sql/00-ddl/30-user/20-grant-role.md)
* [How to Revoke Role From a User](../30-reference/30-sql/00-ddl/30-user/21-revoke-role.md)


## Tables

* [How to Create a Database](../30-reference/30-sql/00-ddl/10-database/ddl-create-database.md)
* [How to Drop a Database](../30-reference/30-sql/00-ddl/10-database/ddl-drop-database.md)
* [How to Create a Table](../30-reference/30-sql/00-ddl/20-table/ddl-create-table.md)
* [How to Drop a Table](../30-reference/30-sql/00-ddl/20-table/ddl-drop-table.md)
* [How to Rename a Table](../30-reference/30-sql/00-ddl/20-table/ddl-rename-table.md)
* [How to Truncate a Table](../30-reference/30-sql/00-ddl/20-table/ddl-truncate-table.md)


## Views

* [How to Create a View](../30-reference/30-sql/00-ddl/60-view/ddl-create-view.md)
* [How to Drop a View](../30-reference/30-sql/00-ddl/60-view/ddl-drop-view.md)
* [How to Alter a View](../30-reference/30-sql/00-ddl/60-view/ddl-alter-view.md)

## Load Data

* [How to Load Data From Local File System](../21-load-data/00-local.md)
* [How to Load Data From Amazon S3](../21-load-data/01-s3.md)
* [How to Load Data From Databend Stages](../21-load-data/02-stage.md)
* [How to Load Data From MySQL](../21-load-data/03-mysql.md)

## Use Cases

* [How to Analyze Github Repository With Databend](../90-learn/00-analyze-github-repo-with-databend.md)
* [How to Analyze Nginx Access Logs With Databend](../90-learn/02-analyze-nginx-logs-with-databend-and-vector.md)


## Back up

* [How to Back up Meta Data](../50-manage/00-metasrv/30-metasrv-backup-restore.md)
* [How to Back up Databases](../50-manage/10-backup-restore/10-backup-and-restore-schema.md)

## Performance

* [How to Benchmark Databend](../90-learn/01-analyze-ontime-with-databend-on-ec2-and-s3.md)
